#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2100four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 2100"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2100four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four21004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four21004xi = {
                1:'1002x-547y1762z',
                2:'1014x-1334y1264z',
                3:'1029x-983y1543z',
                4:'1038x-1798y307z',
                5:'1045x-501y1750z',
                6:'106x-2038y493z',
                7:'1086x-452y1739z',
                8:'1090x-938y1529z',
                9:'1091x-1289y1247z',
                10:'1124x-401y1727z',
                11:'1132x-1744y287z',
                12:'1150x-889y1515z',
                13:'1160x-346y1715z',
                14:'1166x-1239y1230z',
                15:'1193x-289y1703z',
                16:'1207x-836y1500z',
                17:'1224x-1685y266z',
                18:'1224x-229y1690z',
                19:'1238x-1185y1213z',
                20:'124x-95y2094z',
                21:'1251x-167y1678z',
                22:'1262x-779y1485z',
                23:'1274x-103y1665z',
                24:'1295x-36y1652z',
                25:'1307x-1126y1196z',
                26:'1312x-1620y245z',
                27:'1314x-719y1470z',
                28:'1363x-656y1455z',
                29:'1374x-1064y1178z',
                30:'1397x-1551y224z',
                31:'1409x-589y1440z',
                32:'142x-402y2056z',
                33:'1437x-997y1161z',
                34:'1452x-520y1425z',
                35:'146x-100y2092z',
                36:'1477x-1477y203z',
                37:'1490x-447y1409z',
                38:'1497x-926y1143z',
                39:'1525x-372y1394z',
                40:'1554x-1399y182z',
                41:'1554x-852y1126z',
                42:'1556x-294y1378z',
                43:'1583x-214y1362z',
                44:'1606x-132y1346z',
                45:'1606x-774y1108z',
                46:'1624x-48y1330z',
                47:'1627x-1317y161z',
                48:'1655x-694y1090z',
                49:'1695x-1231y141z',
                50:'169x-103y2090z',
                51:'171x-413y2051z',
                52:'1758x-1141y120z',
                53:'1780x-639y1123z',
                54:'1816x-1048y99z',
                55:'1869x-952y78z',
                56:'1917x-853y57z',
                57:'193x-104y2088z',
                58:'1960x-752y36z',
                59:'1997x-648y15z',
                60:'201x-422y2047z',
                61:'213x-2034y473z',
                62:'217x-103y2086z',
                63:'232x-429y2042z',
                64:'241x-99y2083z',
                65:'265x-434y2037z',
                66:'266x-93y2080z',
                67:'290x-85y2078z',
                68:'299x-436y2032z',
                69:'315x-75y2074z',
                70:'320x-2025y452z',
                71:'334x-436y2026z',
                72:'338x-62y2071z',
                73:'343x-835y1895z',
                74:'362x-46y2067z',
                75:'369x-433y2021z',
                76:'384x-29y2064z',
                77:'395x-833y1886z',
                78:'406x-428y2015z',
                79:'406x-9y2060z',
                80:'427x-2010y432z',
                81:'442x-420y2009z',
                82:'447x-828y1877z',
                83:'479x-409y2003z',
                84:'499x-819y1867z',
                85:'515x-396y1996z',
                86:'532x-1989y411z',
                87:'552x-379y1990z',
                88:'552x-807y1857z',
                89:'560x-1186y1639z',
                90:'588x-360y1983z',
                91:'605x-792y1848z',
                92:'623x-338y1976z',
                93:'629x-1169y1626z',
                94:'637x-1962y390z',
                95:'657x-773y1838z',
                96:'658x-314y1969z',
                97:'692x-287y1961z',
                98:'698x-1148y1613z',
                99:'710x-751y1827z',
                100:'724x-256y1954z',
                101:'740x-1929y370z',
                102:'755x-224y1946z',
                103:'761x-726y1817z',
                104:'766x-1124y1599z',
                105:'775x-1443y1313z',
                106:'785x-188y1938z',
                107:'812x-696y1806z',
                108:'813x-151y1930z',
                109:'834x-1095y1585z',
                110:'839x-110y1921z',
                111:'842x-1891y349z',
                112:'856x-1411y1297z',
                113:'861x-664y1795z',
                114:'862x-68y1913z',
                115:'884x-23y1904z',
                116:'900x-1061y1572z',
                117:'910x-628y1784z',
                118:'936x-1375y1280z',
                119:'941x-1848y328z',
                120:'957x-589y1773z',
                121:'965x-1024y1558z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2100four4xi" usage = "target function for charge21004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2100four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2100FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2100FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2100FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2100FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2100FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four21004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2100FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2100FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2100FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four21004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four21004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2100FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2100FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2100FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2100four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    